/* Zadatak 1A:

*/

#include <stdio.h>

    /* Globalne vrijednosti baza za zanimljive brojeve.
       Zanimljivi brojevi su b1^k, b2^k, za k > 1.
       Inicijaliziramo tako da je b1 < b2. */

const int b1 = 2, b2 = 7;

    /* Rekurzivna funkcija iz zadatka. */

    /* Racuna broj rastava broja n u sumu "zanimljivih" prirodnih brojeva.
       U sumi prvo dolaze potencije od b1 (nepadajuce), a zatim potencije
       od b2 (opet, nepadajuce). To osigurava da dobiveni broj rastava
       NE ovisi o poretku pribrojnika. */

    /* Opis parametra:
         n = (preostali) broj kojeg treba rastaviti u sumu,
         b = b1 ili b2 (bitno za eventualni prijelaz s b1 na b2),
         sljed = najmanji dozvoljeni sljedeci pribrojnik (zato da
             pribrojnici rastu).
         U prvom pozivu za dani b je sljed = b^2, a u svim ostalim
         pozivima je sljed = b^k, uz k >= 2, s tim da je onda
         sljed = zadnji stavljeni pribrojnik oblika b^k.
    */

int broj_rastava(int n, int b, int sljed)
{
    int broj = 0;

        /* Provjera ulaznog n obzirom na sljed. */
    if (n < 0) return 0;     /* Ne ide ovako. */
    if (n == 0) return 1;    /* Jedan uspjesan rastav. */

        /* Ovdje je n > sljed. */

        /* Prvo nadji sve rastave s ulaznom bazom b za zanimljive brojeve.
           Variraj sljedeci pribrojnik sljed, pocev od ulazne vrijednosti
           sljed, po potencijama od b, sve dok je sljed <= n. */
    while (1) {
        broj += broj_rastava(n - sljed, b, sljed);

            /* Provjera sljedece potencije (pazim na prikazivost). */
        if (sljed > n / b) break;

            /* Postavi sljed na sljedecu potenciju od b. */
        sljed *= b;
    }

        /* Ako je b = b2 (najveca baza), onda smo gotovi. */
    if (b == b2) return broj;

        /* Ako je b = b1 (jedina preostala mogucnost, jer imamo samo 2 baze),
           onda jos treba pribrojiti sve rastave zadanog n, ali s b = b2, uz
           pocetni pribrojnik (b2)^2 - identicno kao u vanjskom pozivu za b1.
           Uociti: Dovoljno je napraviti ekvivalent VANJSKOG poziva s b = b2,
           tj. NE treba kopija gornje petlje, s inicijalizacijom b = b2 i
           sljed = b2*b2 (taj kod je u komentaru - ispod poziva). */

    broj += broj_rastava(n, b2, b2*b2);

/* Ovo NE treba:

    b = b2;
    sljed = b * b;
    while (1) {
        broj += broj_rastava(n - sljed, b, sljed);
        if (sljed > n / b) break;
        sljed *= b;
    }
*/

    return broj;
}

    /* Glavni program za demo, s primjerom poziva funkcije. */

int main(void)
{
    int n, br_rastava;

        /* Primjeri poziva za primjere iz zadatka. */

    n = 8;
    br_rastava = broj_rastava(n, b1, b1*b1);
    printf("\n Za n = %d, broj rastava = %d\n", n, br_rastava);

    n = 53;
    br_rastava = broj_rastava(n, b1, b1*b1);
    printf("\n Za n = %d, broj rastava = %d\n", n, br_rastava);

    n = b2 * b2;
    br_rastava = broj_rastava(n, b1, b1*b1);
    printf("\n Za n = %d, broj rastava = %d\n", n, br_rastava);

    return 0;
}
