/* Zadatak 2A:

*/

#include <stdio.h>
#include <stdlib.h>

    /* Deklaracija tipa za pokazivac na element liste znamenki. */

typedef struct _element *lista;

    /* Deklaracija tipa za element liste znamenki. */

typedef struct _element {
    int znam;
    lista next;
} element;


    /* Funkcija iz (a) dijela. */
    /* Varijabilni argumenti *p_poc, i *p_kraj su pokazivaci
       na pocetak i kraj perioda, ako je zadana lista omca. */

    /* Skica algoritma: Za svaki element liste, provjeri je li
       njegov sljedbenik neki od elemenata ISPRED njega, ili on sam. */

int test_omca(lista prvi, lista *p_poc, lista *p_kraj)
{
        /* Lokalni pokazivaci na pocetak i kraj perioda.
           Napomena: Inicijalizacija na NULL treba samo za poc,
           i to sluzi samo za slucaj kad je prvi = NULL. */
    lista poc = NULL, kraj;

        /* Pomocni pokazivac za setanje po listi. */
    lista pom;

        /* Logicki indikator za omcu. Ako ostane 0 - imamo
           obicnu listu, ako postane 1 - imamo omcu. */
    int nasli = 0;

        /* Prolaz po listi. Ako nadjemo omcu, izlaz je s break. */
    for (kraj = prvi; kraj != NULL; kraj = kraj->next) {

            /* Zapamti pokazivac na "sljedeci" element.
               Ako je omca, onda je to pocetak perioda.
               Moze se testirati je li NULL, ali nije bitno. */
        poc = kraj->next;

            /* Prodji po prednjem dijelu liste, do elementa na kojeg
               pokazuje kraj (BEZ njega) i provjeri pokazuje li poc
               na neki od "prednjih" elemenata. Ako da - imamo omcu
               i onda prekidamo ovu petlju (ima samo jedna omca). */
        for (pom = prvi; pom != kraj; pom = pom->next)
            if (pom == poc) {
                nasli = 1; break;
            }

            /* Ako smo nasli omcu, prekidamo vanjsku petlju po kraj. */
        if (nasli) break;

            /* Tu je pom = kraj. Ostaje jos mogucnost da imamo omcu
               od jednog elementa, tj. da poc = kraj->next pokazuje
               bas na pom = kraj. Onda i to provjerimo. */
        if (pom == poc) {
            nasli = 1; break;
        }
    }    /* Kraj petlje po pokazivacu kraj. */

        /* Ako smo izasli s break (nasli = 1), onda poc i kraj
           bas pokazuju na pocetak i kraj perioda.
             U protivnom, na kraju petlje je kraj = NULL (zbog prekida
           petlje), a vrijedi i poc = NULL, jer je stavljen na kraj->next
           u ZADNJEM prolazu kroz petlju. Zato NE treba inicijalizacija
           poc i kraj na NULL (osim za poc, kad je prvi = NULL).
             Dakle, za postavljanje varijabilnih argumenata, NE treba
           testirati nasli, vec ih samo postavimo na poc i kraj. */
    *p_poc = poc;
    *p_kraj = kraj;

        /* Vrati nasli kao indikator je li lista omca. */
    return nasli;
}

    /* Pomocna funkcija za ispis decimalnog zapisa broja prikazanog
       zadanom listom. Koristi pokazivace poc i kraj na pocetak
       i kraj perioda (ako period postoji, tj. ako je lista omca).
       Ovdje su poc i kraj "obicni" argumenti, a ne varijabilni.
       Koristi se u funkciji iz (b) dijela zadatka i u glavnom
       programu - za demo (a) dijela. */

void ispis_dec(lista prvi, lista poc, lista kraj)
{
        /* Pomocni pokazivac za setanje po listi. */
    lista pom;

        /* Ispis 0 i tocke, bez obzira na to je li lista prazna ili ne. */
    printf("0.");

        /* Ovdje moze test na prvi = NULL, ali ocekujemo da je
           onda i poc = NULL. */

        /* Ispis znamenki ISPRED peroda.
           Ako je rijeci o obicnoj listi, koja nije omca, onda
           ocekujemo da je poc = NULL, pa prvi dio ispisa ide
           do poc - neovisno o tome je li omca ili ne.
           Ako je lista prazna, onda nema prolaza kroz ovu petlju. */
    for (pom = prvi; pom != poc; pom = pom->next)
        printf("%d", pom->znam);

        /* Ispis znamenki UNUTAR peroda (ako postoji). */
    if (poc != NULL) {
            /* Otvorena uglata zagrada za pocetak perioda. */
        printf("[");

            /* Prolaz kroz znamenke perioda (BEZ zadnje). */
        for (pom = poc; pom != kraj; pom = pom->next)
            printf("%d", pom->znam);

            /* Zadnja znamenka perioda. */
        printf("%d", kraj->znam);

            /* Zatvorena uglata zagrada za kraj perioda. */
        printf("]");
    }

        /* Zavrsi ispis prijelazom u novi red (radi preglednosti). */
    printf("\n");

    return;
}

    /* Funkcija iz (b) dijela. */

    /* Skica algoritma za brisanje znamenki iz perioda:
       - Prvo zapamtimo pokazivac na zadnju znamenku ISPRED perioda
         (ako postoji, sto je ekvivalentno s prvi != poc).
       - Pretvorimo periodicki dio liste, od poc do kraj u obicnu
         listu (bez omce), tj. postavimo kraj->next na NULL.
       - Obrisemo sve trazene znamenke iz te liste i (usput)
         pazimo na zadnji element u toj listi (novi kraj).
       - Ako dobivena lista nije prazna, onda ju prvo objesimo
         na kraj pocetnog dijela liste (onog ispred perioda),
         a zatim ga "vratimo" u omcu.
    */

lista brisi_pisi(lista prvi, lista *p_poc, lista *p_kraj)
{
        /* Lokalni pokazivaci na pocetak i kraj perioda.
           Inicijalizacija na ulazne vrijednosti iz varijabilnih
           argumenata (sluzi za provjeru omce). */
    lista poc = *p_poc, kraj = *p_kraj;

        /* Pomocni pokazivac za setanje po listi. */
    lista pom;

        /* Pomocni pokazivac na zadnjeg u prvom dijelu (ispred perioda). */
    lista zadnji_1;

        /* Pomocni pokazivaci kod brisanja - na prethodni i izbaceni
           element (ne treba ih inicijalizirati. */
    lista preth, izbacen;

        /* Provjera je li lista omca. Tad smatramo da su poc i
           kraj razliciti od NULL, a dovoljno je provjeriti poc. */
    if (poc != NULL) {

            /* Postavi zadnji_1 na element ISPRED poc (ako ga ima).
               U protivnom (poc = prvi), zadnji_1 ostaje NULL. */
        zadnji_1 = NULL;
        for (pom = prvi; pom != poc; pom = pom->next)
             zadnji_1 = pom;

            /* Pretvori period u obicnu listu - poc je pokazivac na
               prvi element, a kraj->next stavljamo na NULL. */
        kraj->next = NULL;

            /* Inicijalizacija za brisanje: pom je prvi u periodu (poc),
               a preth (prethodni, kod brisanja) je NULL. */
        pom = poc;
        preth = NULL;    /* Ne treba. */

            /* Algoritam brisanja u listi od pom do kraj.
               Tu koristimo da je kraj->next postavljen na NULL. */
        while (pom != NULL) {

                /* Provjera znamenke za brisanje - brisemo parne. */
            if (pom->znam % 2 == 0) {

                    /* Pokazivac na element kojeg treba izbaciti. */
                izbacen = pom;

                    /* Izbaci ga iz liste, postavi novi pom.
                       Preth se NE mijenja, zbog izbacivanja. */
                if (pom == poc) {    /* <=> preth == NULL. */
                        /* Izbaci s pocetka perioda, popravi poc. */
                    poc = poc->next;
                    pom = poc;
                }
                else {    /* <=> pom == preth->next. */
                        /* Izbaci unutar perioda, preth je zadnji
                           u sredjenom dijelu perioda. */
                    preth->next = pom->next;
                    pom = preth->next;    /* <=> pom = pom->next; */
                }

                    /* Dealociraj izbacenog. */
                free(izbacen);
            }
            else {    /* Nema izbacivanja, makni preth i pom. */
                preth = pom;
                pom = preth->next;    /* <=> pom = pom->next; */
            }
        }    /* Kraj petlje za brisanje while (pom != NULL). */

            /* Ovdje poc pokazuje na pocetak preostalog perioda (ako je
               neprazan) ili je poc = NULL (obrisali smo cijeli preiod).
               U oba slucaja, prvo "objesi" tu listu IZA zadnji_1 (kraj
               pocetnog neperiodickog dijela), pazeci na promjenu prvog. */
        if (zadnji_1 != NULL)
            zadnji_1->next = poc;
        else
            prvi = poc;

            /* Sad provjerimo sto je ostalo u periodu. */
        if (poc == NULL) {

                /* Ako je poc = NULL, onda smo obrisali CIJELI period,
                   tj. vise NEMA omce. Postavi novi kraj na NULL. */
            kraj = NULL;
        }
        else {
                /* Ovdje je poc != NULL. Onda preth pokazuje na ZADNJEG
                   u preostalom periodu, tj. to je novi kraj. Jos treba
                   ponovno zatvoriti omcu, tj. staviti kraj->next = poc. */
            kraj = preth;
            kraj->next = poc;
        }

            /* Ako je bila omca, postavi varijabilne argumente na nove
               vrijednosti pocetka i kraja perioda - nakon brisanja. */
        *p_poc = poc;
        *p_kraj = kraj;
    }    /* Kraj if (poc != NULL). */


        /* Decimalni zapis broja prikazanog listom
           (nakon eventualnog brisanja znamenki). */
    ispis_dec(prvi, poc, kraj);

        /* Vrati pokazivac na prvi element nakon brisanja. */
    return prvi;
}

    /* Pomocna funkcija za kreiranje dvije liste iz primjera
       za zadatak (nema provjere alokacije).
       Ulaz su polje od n (= 5) znamenki i logicka varijabla omca.
       Ako je omca = 1, onda se kreira omca na treci element. */

lista kreiraj(int znamenke[], int n, int omca)
{
    lista prvi, preth, zadnji, treci = NULL;
    int i;

        /* Za svaki slucaj, ako je n <= 0, vrati praznu listu. */
    if (n <= 0) return NULL;

        /* Prvi element. */
    prvi = (lista) malloc(sizeof(element));
    prvi->znam = znamenke[0];
    preth = prvi;

        /* Preostalih n - 1 elementa. */
    for (i = 2; i <= n; ++i) {
        zadnji = (lista) malloc(sizeof(element));
        zadnji->znam = znamenke[i - 1];
        preth->next = zadnji;
        preth = zadnji;

            /* Ako je omca, zapamti pokazivac na 3. element. */
        if (omca && (i == 3)) treci = zadnji;
    }

        /* Pokazivac u zadnjem elementu liste postavljamo na treci
           (ostaje inicijaliziran na NULL, ako nije omca). */
    preth->next = treci;

    return prvi;
}

    /* Glavni program za demo. */

int main(void)
{
        /* Polje od 5 znamenki za oba broja iz primjera. */
    int br_znam = 5;
    int znamenke[5] = { 5, 4, 1, 2, 2 };

        /* Pokazivaci na pocetke za oba primjera. */
    lista prvi_1, prvi_2;

        /* Pokazivaci za pocetak i kraj perioda u prvoj i drugoj listi
           (za obje funkcije) i pomocni pokazivac za brisanje liste. */
    lista poc_1, kraj_1, poc_2, kraj_2, pom;

        /* Logicki indikator je li lista omca ili ne.
           Rezultat funkcije iz (a) */
    int omca;


        /* Kreiraj obicnu listu za primjer. */
    prvi_1 = kreiraj(znamenke, br_znam, 0);

        /* Kreiraj omcu za primjer. */
    prvi_2 = kreiraj(znamenke, br_znam, 1);


    printf("\nTestiranje funkcije iz (a):\n");

        /* Provjera prve liste - poziv funkcije iz (a). */
    omca = test_omca(prvi_1, &poc_1, &kraj_1);

    printf("  Decimalni zapis broja iz prve liste: ");
    ispis_dec(prvi_1, poc_1, kraj_1);
    if (omca)
        printf("  Prva lista je omca\n");
    else
        printf("  Prva lista je obicna lista\n");

        /* Provjera druge liste - poziv funkcije iz (a). */
    omca = test_omca(prvi_2, &poc_2, &kraj_2);

    printf("  Decimalni zapis broja iz druge liste: ");
    ispis_dec(prvi_2, poc_2, kraj_2);
    if (omca)
        printf("  Druga lista je omca\n");
    else
        printf("  Druga lista je obicna lista\n");


    printf("\nTestiranje funkcije iz (b):\n");

        /* Brisanje i ispis za prvu listu - poziv funkcije iz (b). */
    printf("  Ispis za prvu listu nakon brisanja: ");
    prvi_1 = brisi_pisi(prvi_1, &poc_1, &kraj_1);

        /* Brisanje i ispis za drugu listu - poziv funkcije iz (b). */
    printf("  Ispis za drugu listu nakon brisanja: ");
    prvi_2 = brisi_pisi(prvi_2, &poc_2, &kraj_2);


        /* Brisanje (dealokacija elemenata) za obje liste.
           Prva lista je obicna lista - petlja ide do NULL. */
    while (prvi_1 != NULL) {
        pom = prvi_1;
        prvi_1 = prvi_1->next;
        free(pom);
    }
        /* Druga lista je omca - zato treba OPREZ:
           petlja ide do kraj_2 (ne NULL), a onda dealociramo i kraj_2. */
    while (prvi_2 != kraj_2) {
        pom = prvi_2;
        prvi_2 = prvi_2->next;
        free(pom);
    }
    free(kraj_2);

    return 0;
}
