/* Zadatak 3A:

*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

    /* Funkcija promijeniA iz (a) dijela. */

char** promijeniA(char **M, int n, int k)
{
    char **MM;
    int i, j, i_kraj;
    char tmp;

        /* Provjera ulaznog n. Ako nije paran, ispisi poruku
           o gresci i vrati NULL. */
    if (n % 2 != 0) {
        printf(" Greska: n nije paran!\n");
        return NULL;
    }

        /* Alokacija novog polja MM, dimenzija n puta n.
           Prvo alokacija pokazivaca MM na polje od n pokazivaca na
           redove, a zatim alokacija svakog reda MM[i], duljine n.
           Odmah kopiramo M u MM. */
    MM = (char **) malloc(n * sizeof(char *));
    for (i = 0; i < n; ++i) {
        MM[i] = (char *) malloc(n * sizeof(char));
        for (j = 0; j < n; ++j)
            MM[i][j] = M[i][j];
    }

        /* Prva transformacija. */
    for (i = 1; i < n; ++i)
        for (j = 0; j < i; ++j)

                /* Ako su MM[i][j] i MM[j][i] znamenke, na oba mjesta
                   stavi njihov zbroj modulo 10 (kao znak). Pretvori
                   znakove u intove, zbroji modulo 10, vrati u char. */
            if (isdigit(MM[i][j]) && isdigit(MM[j][i])) {
                tmp = ((MM[i][j] - '0') + (MM[j][i] - '0')) % 10 + '0';
                MM[i][j] = tmp;
                MM[j][i] = tmp;
            }

        /* Druga transformacija - zamjene susjednih parova redaka. */
    for (i = 0; i < n; i += 2)    /* Pomak za 2. */

            /* Zamjena redova s indeksima i, i+1 (brojimo od 0). */
        for (j = 0; j < n; ++j) {
            tmp = MM[i][j];
            MM[i][j] = MM[i + 1][j];
            MM[i + 1][j] = tmp;
        }

        /* Napomena: Ovdje ocekujem da je k >= 0 (bez provjere).
           Ne treba provjeriti je li k < n. Ako je k >= n, onda
           se donje dvije petlje nece izvrsiti, tj. nece se
           indeksirati nepostojeci elementi. */

        /* Treca transformacija, 1. dio:
           Okreni k-tu donju glavnu dijagonalu (i za k = 0). */
        /* Indeksi elemenata su (i, i - k), i = k, ..., n - 1.
           Kod zamjene, i odgovara gornjem redu, a i_kraj donjem.
           Indeks i se povecava za 1, a i_kraj se smanjuje za 1. */
    i_kraj = n - 1;
    for (i = k; i < i_kraj; ++i, --i_kraj) {
        tmp = MM[i][i - k];
        MM[i][i - k] = MM[i_kraj][i_kraj - k];
        MM[i_kraj][i_kraj - k] = tmp;
    }

        /* Treca transformacija, 2. dio: Promjena velikih slova u mala
           na k-toj gornjoj glavnoj dijagonali (i za k = 0). */
        /* Indeksi elemenata su (i - k, i), i = k, ..., n - 1.
           Ne treba pitati je li veliko slovo, jer tolower mijenja
           samo velika slova, a sve ostalo vrati isto. */
    for (i = k; i < n; ++i)
        MM[i - k][i] = tolower(MM[i - k][i]);

        /* Vrati pokazivac na novo polje MM. */
    return MM;
}

    /* Funkcija brojA iz (b) dijela. */

int brojA(char **M, int m, int n, char *str)
{
    int broj = 0, len, i, j, nasli, k;

        /* Provjera duljine ulaznog stringa. */
    len = strlen(str);
    if (len == 0) return 0;

        /* Smanjimo len za 1, tako da je str[len] zadnji znak u str. */
    --len;

        /* Trazenje stringa str odozdo nagore u matrici M.
           Zbog duljine len, treba gledati samo redove s
           indeksima od len do m - 1. */
    for (i = len; i < m; ++i)
        for (j = 0; j < n; ++j) {

                /* Pocetna pozicija je M[i][j]. Trazimo prema gore,
                   zato od i oduzimamo k. */
            nasli = 1;
            for (k = 0; k <= len; ++k)
                if (M[i - k][j] != str[k]) {
                    nasli = 0;
                    break;
                }

                /* Ako je nasli ostao na 1, povecaj broj. */
            if (nasli) ++broj;
        }

        /* Vrati broj nadjenih stringova. */
    return broj;
}

    /* Pomocna funkcija za ispis niza nizova M, dimenzije m puta n. */

void ispisi(char **M, int m, int n)
{
    int i, j;

    printf("  Niz nizova dimenzije %d puta %d:\n", m, n);

    for (i = 0; i < m; ++i) {
            /* Ispis i-tog reda niza nizova. */
        printf("    %d. red:  ", i + 1);
        for (j = 0; j < n; ++j)
            printf(" %c", M[i][j]);
        printf("\n");
    }

    return;
}

    /* Glavni program za demo. */

int main(void)
{
        /* Fiksna matrica znakova Mat_A za (a) dio zadatka. */
    int n = 4, k = 1;
    char Mat_A[4][4] = {
        { 'a', '2', 'b', 'c' },
        { '3', 'D', 'e', 'f' },
        { '4', 'G', 'H', 'p' },
        { 'v', 'w', 'q', '8' }
    };
        /* Sad napravim niz nizova iz matrice Mat_A,
           tj. polje pokazivaca na redove te matrice. */
    char *MA[4] = { Mat_A[0], Mat_A[1], Mat_A[2], Mat_A[3] };

        /* Fiksna matrica znakova MB za (b) dio zadatka.
           Za DEMO, ovdje NE polazim od "prave" matrice (kao gore),
           vec koristim polje pokazivaca na stringove. */
    char *MB[5] = {
	"aaFaD",
	"aaEaE",
	"FaDEF",
	"EaEaa",
	"Daaaa"
    };
        /* Fiksni string za trazenje u (b) dijelu zadatka. */
    char *str = "DEF";

        /* Pokazivac na jedan niz nizova znakova,
           za rezultat funkcije iz (a). */
    char **MM;

        /* Broj za rezultat funkcije iz (b). */
    int broj, i;


        /* Ispis polaznog polja MA po redovima. */
    printf("\n");
    printf("Polazno polje M za (a) dio:\n");
    ispisi(MA, n, n);

        /* Poziv funkcije iz (a). */
    MM = promijeniA(MA, n, k);

        /* Ispis novog polja MM po redovima. */
    printf("\n");
    printf("Transformirano polje MM nakon funkcije iz (a):\n");
    ispisi(MM, n, n);


        /* Ispis polaznog polja MB po redovima. */
    printf("\n");
    printf("Polazno polje M za (b) dio:\n");
    ispisi(MB, 5, 5);

        /* Poziv funkcije iz (b). */
    broj = brojA(MB, 5, 5, str);

        /* Ispis rezultata. */
    printf("\n");
    printf(" U polju MB string \"%s\" se javlja %d puta\n", str, broj);


        /* Petlja za dealokaciju svih redova u MM, a na kraju
           ide dealokacija polja pokazivaca na redove u MM. */
    for (i = 0; i < n; ++i)
        free(MM[i]);
    free(MM);

    return 0;
}
