/* Zadatak 4A:

*/

#include <stdio.h>

    /* Pomocna funkcija za citanje zadane ulazne datoteke
       i zbrajanje ucitanih bodova na ukupni zbroj bodova
       u tablici za sve studente.
         Nema kontrole ucitanih podataka - pretpostavlja se
       da datoteka ima oblik opisan u zadatku. */

void zbroji_bodove(char* f_ime, int uk_bodovi[])
{
        /* Podaci iz jednog reda ulazne datoteke.
           Spremaju se kao int, iako moze i kao unsigned int. */
    int matbr, bodovi_1, bodovi_2;

        /* Broj studenata i indeks petlje za citanje. */
    int n, i;

        /* Ulazna datoteka, odmah ju otvori. */
    FILE *f = fopen(f_ime, "r");

        /* Provjera otvaranja (NIJE potrebno za rjesenje zadatka). */
    if (f == NULL) return;

        /* Ucitaj broj studenata koji su pristupili kolokviju. */
    fscanf(f, "%d", &n);

        /* Petlja za citanje ostalih n redova. */
    for (i = 1; i <= n; ++i) {

            /* Ucitaj matbr, bodovi_1, bodovi_2. */
        fscanf(f, "%d%d%d", &matbr, &bodovi_1, &bodovi_2);

            /* Dodaj bodove studentu s ucitanim maticnim brojem.
               Provjeri je li raniji "zbroj" bio -1. Ako je,
               onda spremi zbroj (nemoj ga dodati na -1).
               Inace, dodaj bodove na ranije spremljene. */
        if (uk_bodovi[matbr - 1] == -1)
                /* Spremi zbroj bodova. */
            uk_bodovi[matbr - 1] = bodovi_1 + bodovi_2;
        else
                /* Dodaj zbroj bodova. */
            uk_bodovi[matbr - 1] += bodovi_1 + bodovi_2;

    }
        /* Zatvaranje ulazne datoteke f. */
    fclose(f);
}

int main(void)
{
        /* Tablica zbroja bodova po studentima.
           Zbroj za studenta matbr je na indeksu matbr - 1. */
    int uk_bodovi[99];
    int matbr;

        /* Broj studenata koji su se pojavili na bar jednom kolokviju,
           suma njihovih bodova i prosjek (za kriterij prolaza/pada). */
    int br_stud = 0, suma = 0;
    double prosjek = 0.0;

        /* Ime izlazne datoteke za studenta. To je string oblika
           "matbr.txt", s tim da matbr ima najvise 2 znamenke.
           Dovoljno je 7 znakova za pojedinu grupu zadatka.
             Promjena: Imena su oblika "a_matbr.txt" ili "b_matbr.txt",
           tako da se razlikuju izlazne datoteke za razne grupe.
           Onda treba 9 znakova. */
    char izl_ime[9];

        /* Izlazna datoteka za pojedinog studenta. */
    FILE *izlaz;

        /* Inicijalizacija tablice na -1, zato da mozemo prepoznati
           je li student pristupio nekom kolokviju ili ne.
           Ako je njegov zbroj bodova = -1, onda se uopce nije pojavio.
           Za takve studente NE kreiramo izlaznu datoteku. */
    for (matbr = 1; matbr <= 99; ++matbr)
        uk_bodovi[matbr - 1] = -1;

        /* Dodamo bodove iz obje ulazne datoteke,
           pozivom funkcije zbroji_bodove. */
    zbroji_bodove("prvi_kolokvij.txt", uk_bodovi);
    zbroji_bodove("drugi_kolokvij.txt", uk_bodovi);

        /* Nadji prosjek ukupnih suma za pristigle. */
    for (matbr = 1; matbr <= 99; ++matbr)

            /* Provjera je li student matbr pristupio nekom kolokviju.
               Ako je, onda mu je suma bodova >= 0. */
        if (uk_bodovi[matbr - 1] >= 0) {
            ++br_stud;
            suma += uk_bodovi[matbr - 1];
        }

        /* Ako je ukupni broj studenata jednak 0 (tj. nitko
           nije izasao ni na jedan kolokvij), onda smo gotovi.
           Sluzi tome da ne dijelimo s nulom za prosjek. */
    if (br_stud == 0) return 0;
    prosjek = suma / br_stud;

        /* Kreiranje izlaznih datoteka za sve koji su pristupili
           bar jednom kolokviju. */
    for (matbr = 1; matbr <= 99; ++matbr)

            /* Provjera je li student matbr pristupio nekom kolokviju.
               Ako je, onda mu je suma bodova >= 0. */
        if (uk_bodovi[matbr - 1] >= 0) {

                /* Pripremi ime izlazne datoteke pisanjem u string.
                   Promjena: Tu se dodaje "a_" ispred matbr. */
            sprintf(izl_ime, "a_%d.txt", matbr);

                /* Kreiraj njegovi datoteku. */
            izlaz = fopen(izl_ime, "w");

                /* Ispis - prema kriteriju za pad/prolaz. */
            if (uk_bodovi[matbr - 1] < prosjek)
                fprintf(izlaz, "PAD\n");
            else
                fprintf(izlaz, "POLOZENO\n");

            fclose(izlaz);
        }

    return 0;
}
