/* Zadatak 4B:

*/

#include <stdio.h>

    /* Pomocna funkcija za citanje zadane ulazne datoteke
       i zbrajanje ucitanih bodova na ukupni zbroj bodova
       u tablici za sve studente.
         Nema kontrole ucitanih podataka - pretpostavlja se
       da datoteka ima oblik opisan u zadatku. */

void zbroji_bodove(char* f_ime, int uk_bodovi[])
{
        /* Podaci iz jednog reda ulazne datoteke.
           Spremaju se kao int, iako moze i kao unsigned int. */
    int matbr, bodovi;

        /* Broj studenata i indeks petlje za citanje. */
    int n, i;

        /* Ulazna datoteka, odmah ju otvori. */
    FILE *f = fopen(f_ime, "r");

        /* Provjera otvaranja (NIJE potrebno za rjesenje zadatka). */
    if (f == NULL) return;

        /* Ucitaj broj studenata koji su pristupili provjeri. */
    fscanf(f, "%d", &n);

        /* Postavi n na 2*n, za preostalih broj redova. */
    n = 2*n;

        /* Petlja za citanje ostalih n redova. */
    for (i = 1; i <= n; ++i) {

            /* Ucitaj matbr, bodovi. */
        fscanf(f, "%d%d", &matbr, &bodovi);

            /* Dodaj bodove studentu s ucitanim maticnim brojem.
               Provjeri je li raniji "zbroj" bio -1. Ako je,
               onda spremi bodove (nemoj ih dodati na -1).
               Inace, dodaj bodove na ranije spremljene. */
        if (uk_bodovi[matbr - 1] == -1)
                /* Spremi broj bodova. */
            uk_bodovi[matbr - 1] = bodovi;
        else
                /* Dodaj broj bodova. */
            uk_bodovi[matbr - 1] += bodovi;

    }
        /* Zatvaranje ulazne datoteke f. */
    fclose(f);
}

int main(void)
{
        /* Tablica zbroja bodova po studentima.
           Zbroj za studenta matbr je na indeksu matbr - 1. */
    int uk_bodovi[99];
    int matbr;

        /* Ime izlazne datoteke za studenta. To je string oblika
           "matbr.txt", s tim da matbr ima najvise 2 znamenke.
           Dovoljno je 7 znakova za pojedinu grupu zadatka.
             Promjena: Imena su oblika "a_matbr.txt" ili "b_matbr.txt",
           tako da se razlikuju izlazne datoteke za razne grupe.
           Onda treba 9 znakova. */
    char izl_ime[9];

        /* Izlazna datoteka za pojedinog studenta. */
    FILE *izlaz;

        /* Inicijalizacija tablice na -1, zato da mozemo prepoznati
           je li student pristupio nekoj provjeri ili ne.
           Ako je njegov zbroj bodova = -1, onda se uopce nije pojavio.
           Za takve studente NE kreiramo izlaznu datoteku. */
    for (matbr = 1; matbr <= 99; ++matbr)
        uk_bodovi[matbr - 1] = -1;

        /* Dodamo bodove iz obje ulazne datoteke,
           pozivom funkcije zbroji_bodove. */
    zbroji_bodove("prva_provjera.txt", uk_bodovi);
    zbroji_bodove("druga_provjera.txt", uk_bodovi);

        /* Kreiranje izlaznih datoteka za sve koji su pristupili
           bar jednoj provjeri. */
    for (matbr = 1; matbr <= 99; ++matbr)

            /* Provjera je li student matbr pristupio nekoj provjeri.
               Ako je, onda mu je suma bodova >= 0. */
        if (uk_bodovi[matbr - 1] >= 0) {

                /* Pripremi ime izlazne datoteke pisanjem u string.
                   Promjena: Tu se dodaje "b_" ispred matbr. */
            sprintf(izl_ime, "b_%d.txt", matbr);

                /* Kreiraj njegovi datoteku. */
            izlaz = fopen(izl_ime, "w");

                /* Ispis - prema kriteriju za pad/prolaz. */
            if (uk_bodovi[matbr - 1] < 100)
                fprintf(izlaz, "PAD\n");
            else
                fprintf(izlaz, "POLOZENO\n");

            fclose(izlaz);
        }

    return 0;
}
